require "luas.shortcuts"
require "luas.extendedLoader"
--
--possible: outputs with love.graphics.print( "", 5, 5, 0, 2, 2)


LevelSettings = Object:extend()													--Task AAU (part 2) levelSettings for level info like enemy projectile speeds, randomizers ect.


function LevelSettings.new(self)
	
	--why not use globals for something like this
	levlSetdebug = true
	
	self.setDefaults(self)
end

function LevelSettings.setDefaults(self)

	--customize for other levelspecific variations such as enemy speeds.
	--it is game specific
	
	--simple shooting randomizer template
	levlAShootRateRnd    = 200 --randomize shooting at "thisvalue" updates out of 1000 updates
	levlAShootRateRndMax = 1000
	levlAShootDoRnd      = 40  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
	levlAShootDoRndMax   = 100
	
	levlBShootRateRnd    = 200 --randomize shooting at "thisvalue" updates out of 1000 updates
	levlBShootRateRndMax = 1000
	levlBShootDoRnd      = 50--300  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
	levlBShootDoRndMax   = 100
	
	levlCShootRateRnd    = 200 --randomize shooting at "thisvalue" updates out of 1000 updates
	levlCShootRateRndMax = 1000
	levlCShootDoRnd      = 25--35  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
	levlCShootDoRndMax   = 100
	
	levlDShootRateRnd    = 200 --randomize shooting at "thisvalue" updates out of 1000 updates
	levlDShootRateRndMax = 1000
	levlDShootDoRnd      = 30--40  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
	levlDShootDoRndMax   = 100
	
	--basic enemy bulletspeed x/y
	levlAEnmBulSpdBasicX  = 0.0
	levlAEnmBulSpdRndX    = 0.0
	levlAEnmBulSpdPosFactorX = 0.0
	levlAEnmBulSpdBasicY  = 1.0 --TODO abstimmen und auf bullets und +- bei y standardisieren
	levlAEnmBulSpdRndY    = 0.4
	levlAEnmBulSpdPosFactorY = 2.0
	
	--basic enemy bulletspeed x/y
	levlBEnmBulSpdBasicX  = 0.0
	levlBEnmBulSpdRndX    = 0.5
	levlBEnmBulSpdPosFactorX = 0.3
	levlBEnmBulSpdBasicY  = 1.0 --TODO abstimmen und auf bullets und +- bei y standardisieren
	levlBEnmBulSpdRndY    = 0.4
	levlBEnmBulSpdPosFactorY = 2.0
	--
	levlBEnmBulStraightChance = 50
	
	
	--basic enemy bulletspeed x/y
	levlCEnmBulSpdBasicX  = 0.0
	levlCEnmBulSpdRndX    = 1.0
	levlCEnmBulSpdPosFactorX = 1.5
	levlCEnmBulSpdBasicY  = 1.0 --TODO abstimmen und auf bullets und +- bei y standardisieren
	levlCEnmBulSpdRndY    = 0.4
	levlCEnmBulSpdPosFactorY = 2.0
	--
	levlCEnmBulStraightChance = 20
	
	
	--basic enemy bulletspeed x/y
	levlDEnmBulSpdBasicX  = 0.0
	levlDEnmBulSpdRndX    = 1.0
	levlDEnmBulSpdPosFactorX = 1.5
	levlDEnmBulSpdBasicY  = 1.0 --TODO abstimmen und auf bullets und +- bei y standardisieren
	levlDEnmBulSpdRndY    = 0.4
	levlDEnmBulSpdPosFactorY = 2.0
	--
	levlDEnmBulStraightChance = 20
	--
	levlDSpreadshotChance = 80 --out of 1000
	
	
	--spread shot keep name bigbullets for copy and paste simplicity
	levlEnmBigBulSpdBasicY = 2.5*0.5
	levlEnmBigBulSpdSlowdorn3WayY = 0.2*0.5
	levlEnmBigBulSpdSlowdorn4WayY = 0.3*0.5
	levlEnmBigBulSpdSlowdorn5WayY = 0.4*0.5
	levlEnmBigBulSpd3WayX = 1.5*0.5
	levlEnmBigBulSpd4WayX = 0.75*0.5
	levlEnmBigBulSpd5WayX = 3.0*0.5
	--
	levlBigShotMaxWays = 5
	
	
	
	levlEnmCRoamSpdBasic = 0.5 --basic initial speed component,  alter with level
	levlEnmCRoamSpdExtra = 0.8
	levlEnmCDirChangeTimeBasic = 20 --8 --BIG impact!!!
	levlEnmCDirChangeTimeExtra = 80--30 --short
	
	
	levlEnmCDiveSpdBasicX = 0.5
	levlEnmCDiveSpdRndX = 1.0
	levlEnmCDiveSpdPosfactorX = 1.5
	--
	levlEnmCDiveSpdBasicY = 0.5
	levlEnmCDiveSpdRndY = 0.5
	levlEnmCDiveSpdPosfactorY = 2.0
	--
	levlEnmCDiveAllowed = 2
	--
	levlEnmCDiveRateRnd    = 200
	levlEnmCDiveRateRndMax = 1000
	levlEnmCDiveDoRnd      = 10
	levlEnmCDiveDoRndMax   = 100
	
	
	levlDoSpawnEnemyE = false
	--
	levlMaxEnemyEAllowed = 1
	--
	levlEnemyESpawnRateRnd    = 50
	levlEnemyESpawnRateRndMax = 1000
	levlEnemyESpawnDoRnd      = 15
	levlEnemyESpawnDoRndMax   = 100
	--
	levlEnemyEMagnY = 1.7
	levlEnemyEMagnRndY = 0.5
	levlEnemyEMagnX = 1.5
	levlEnemyEMagnRndX = 1.0
	--
	levlEnemyESlowDwnY = 0.1
	
end

--according to gamelevel number, adjust 
function LevelSettings.doCustomize(self, aGameLevelNumber)

	if aGameLevelNumber == 1 then
	
		self.setDefaults(self)
		
	elseif aGameLevelNumber == 5 then
	
		self.setDefaults(self)
		
		levlAShootDoRnd      = 60  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
		levlBShootDoRnd      = 300  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
		levlCShootDoRnd      = 35  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
		levlDShootDoRnd      = 40  --with levlShootRateRnd fulfilled, apply it with a likelyhood of "thisvalue" percent
		
	elseif aGameLevelNumber == 9 then
	
		self.setDefaults(self)
		
		levlDoSpawnEnemyE = true
		--
		levlMaxEnemyEAllowed = 2
		--
		levlEnemyESpawnDoRnd      = 15
		--
		levlEnemyEMagnY = 2.7
		levlEnemyEMagnRndY = 0.9
		levlEnemyEMagnX = 1.2
		levlEnemyEMagnRndX = 0.8
		--
		levlEnemyESlowDwnY = 0.1
		
	elseif aGameLevelNumber == 13 then
	
		print("did customize level 13")
	
		self.setDefaults(self)
		
		levlAShootDoRnd      = 60 
		levlBShootDoRnd      = 80  
		levlCShootDoRnd      = 28
		levlDShootDoRnd      = 37  
		
		levlEnmCDiveAllowed = 3
		
		levlDoSpawnEnemyE = true
		--
		levlMaxEnemyEAllowed = 2
		--
		levlEnemyESpawnDoRnd      = 15
		--
		levlEnemyEMagnY = 2.7
		levlEnemyEMagnRndY = 0.9
		levlEnemyEMagnX = 1.2
		levlEnemyEMagnRndX = 0.8
		--
		levlEnemyESlowDwnY = 0.1
		
		
	elseif aGameLevelNumber == 17 then
	
		print("did customize level 17")
	
		self.setDefaults(self)
		
		levlDoSpawnEnemyE = true
		--
		levlMaxEnemyEAllowed = 3
		--
		levlEnemyESpawnDoRnd      = 15
		--
		levlEnemyEMagnY = 2.7
		levlEnemyEMagnRndY = 0.9
		levlEnemyEMagnX = 1.2
		levlEnemyEMagnRndX = 0.8
		--
		levlEnemyESlowDwnY = 0.1
		
	elseif aGameLevelNumber == 21 then
	
		print("did customize level 21")
		
		self.setDefaults(self)
		
		levlAShootDoRnd      = 50 
		levlBShootDoRnd      = 65  
		levlCShootDoRnd      = 37
		levlDShootDoRnd      = 34 
		
		levlDoSpawnEnemyE = true
		--
		levlMaxEnemyEAllowed = 3
		--
		levlEnemyESpawnDoRnd      = 15
		--
		levlEnemyEMagnY = 2.4--2.7
		levlEnemyEMagnRndY = 0.5--0.9
		levlEnemyEMagnX = 1.2
		levlEnemyEMagnRndX = 0.8
		--
		levlEnemyESlowDwnY = 0.1
		
	elseif aGameLevelNumber == 25 then
		
		print("did customize level 25")
		
		self.setDefaults(self)
		
		levlAShootDoRnd      = 50
		levlBShootDoRnd      = 65  
		levlCShootDoRnd      = 27
		levlDShootDoRnd      = 34  
		
		levlDoSpawnEnemyE = true
		--
		levlMaxEnemyEAllowed = 2
		--
		levlEnemyESpawnDoRnd      = 15
		--
		levlEnemyEMagnY = 1.7
		levlEnemyEMagnRndY = 1.3
		levlEnemyEMagnX = 1.4
		levlEnemyEMagnRndX = 0.9
		--
		levlEnemyESlowDwnY = 0.1
		
	elseif aGameLevelNumber == 29 then
	
		print("did customize level 29")
	
		self.setDefaults(self)
		
		levlAShootDoRnd      = 55
		levlBShootDoRnd      = 80  
		levlCShootDoRnd      = 31
		levlDShootDoRnd      = 37 
		
		levlDoSpawnEnemyE = true
		--
		levlMaxEnemyEAllowed = 1
		--
		levlEnemyESpawnDoRnd      = 20
		--
		levlEnemyEMagnY = 1.7
		levlEnemyEMagnRndY = 0.5
		levlEnemyEMagnX = 1.5
		levlEnemyEMagnRndX = 1.0
		--
		levlEnemyESlowDwnY = 0.1
	end

end

function LevelSettings.doUpdate(self)
	--do nothing
end

function LevelSettings.draw(self)
	if levlSetdebug==true then
		--if debug flag is set, may want to print some settings on screen
		--love.graphics.print( "LevelSettings", 5, 5, 0, 2, 2)
		--love.graphics.print( "EnmBullets:", 5, 15, 0, 2, 2)
		--love.graphics.print( "Y-Param: RangeY "..levlEnmBulRangeY.." basicSpdY "..levlEnmBulSpdBasicY.." RndY "..levlEnmBulSpdRndY.." " , 5, 30, 0, 2, 2)
		--love.graphics.print( "X-Param: RangeX "..levlEnmBulRangeY.." basicSpdX "..levlEnmBulSpdBasicY.." RndX "..levlEnmBulSpdRndY.." " , 5, 45, 0, 2, 2)
	end
end

