
require "luas.shortcuts"
require "luas.extendedLoader"


--HOT TODOS extended loader (enemy bounding box) -> DONE
--          globals: enemy container structure --
--          game + demo mode loading level (?) + enemy from level pictures + activate in container

ExplosionA = Object:extend()

function ExplosionA.new(self)

	self.active = false
	
	self.x = 0
	self.y = 0

	self.frames = {}
	
	self.anmStep       = 17 --use for index of frame (here set invalid)
	self.anmThresh     = 16

end

function ExplosionA.activate(self, aPX, aPY)

	self.active = true

	self.x = aPX
	self.y = aPY
	self.anmStep = 1
	
	self.frames[1] = enmExplodeAGph[1]
	self.frames[2] = enmExplodeAGph[1]
	self.frames[3] = enmExplodeAGph[1]
	self.frames[4] = enmExplodeAGph[1]
	self.frames[5] = enmExplodeAGph[2]
	self.frames[6] = enmExplodeAGph[2]
	self.frames[7] = enmExplodeAGph[2]
	self.frames[8] = enmExplodeAGph[2]
	self.frames[9] = enmExplodeAGph[3]
	self.frames[10] = enmExplodeAGph[3]
	self.frames[11] = enmExplodeAGph[3]
	self.frames[12] = enmExplodeAGph[3]
	self.frames[13] = enmExplodeAGph[4]
	self.frames[14] = enmExplodeAGph[4]
	self.frames[15] = enmExplodeAGph[4]
	self.frames[16] = enmExplodeAGph[4]


	
end

function ExplosionA.deactivate(self)

	self.active = false

	self.x = 0
	self.y = 0
	--self.explIndex = 0 --TODO that's inconsistent/Bug as self.explIndex doesnt exist elsewhere in this class/(at all?)
end

function ExplosionA.doUpdate(self)

	if self.active then
		if self.anmStep <= self.anmThresh then
			self.anmStep = self.anmStep + 1
		end
	
		if self.anmStep > self.anmThresh then
			self.deactivate(self)
		end
	end
end

function ExplosionA.draw(self)
	if self.active then
		lg.draw(self.frames[self.anmStep], self.x, self.y, 0, 1, 1)
	end
end


