ShotSoundPool = Object:extend()


function ShotSoundPool.new(self)--, aPosX, aPosY) position only known at activation time
	self.index = 1
	self.maxIndex = 3
	
end

function ShotSoundPool.stop(self)
	self.index = self.index + 1
	
	if self.index > self.maxIndex then
		self.index = 1
	end
	
	if self.index == 1 then
		shot1Snd:stop()
	elseif self.index == 2 then
		shot2Snd:stop()
	elseif self.index == 3 then
		shot3Snd:stop()
	end
end

function ShotSoundPool.play(self)
	
	if self.index == 1 then
		shot1Snd:play()
	elseif self.index == 2 then
		shot2Snd:play()
	elseif self.index == 3 then
		shot3Snd:play()
	end
end
